// TODO: Move that in another folder

let template ={};

TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), []);

template.requirements = { "all": [{ "entity": { "class": "Village", "number": 5 } }, { "civ": "athen" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), [{ entities: [{ class:"Village", number:5, check:"count" }] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "spart"), false);

template.requirements = { "all": [{ "entity": { "class": "Village", "numberOfTypes": 5 } }, { "civ": "athen" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), [{ entities:[{ class:"Village", number:5, check:"variants" }] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "spart"), false);

template.requirements = { "all": [{ "tech": "phase_town" }, { "notciv": "maur" }, { "notciv": "spart" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), [{ "techs": ["phase_town"] }]);

template.requirements = { "all": [{ "tech": "phase_town" }, { "all": [{ "notciv": "maur" }, { "notciv": "spart" }] }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), [{ "techs": ["phase_town"] }]);

template.requirements = { "all": [{ "entity": { "class": "Village", "numberOfTypes": 5 } }, { "entity": { "class": "Melee", "number": 6 } }, { "civ": "athen" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), 
[{ entities: [{ class:"Village", number:5, check:"variants" }, { class:"Melee", number:6, check:"count" }] } ]);

template.requirements = { "all": [{ "tech": "phase_city" }, { "any": [{ "civ": "brit"}, { "civ": "gaul"}, { "civ": "iber"}, { "civ": "mace"}, { "civ": "maur" }, { "civ": "rome" }] }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"), false);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "brit"), [{ "techs": ["phase_city"] }]);

template.requirements =
{ "all": [{ "any":[{ "entity": { "class": "Village", "numberOfTypes": 5 } },
	{ "entity": { "class": "Melee", "number": 6 } }] }, { "civ": "athen" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "athen"),
	[{ "entities" : [{ class:"Village", "number":5, "check":"variants" }] }, { "entities": [{ class: "Melee", "number": 6, "check": "count" }] }]); 

template.requirements =
{ "all": [{ "tech": "tech1" }, { "any": [{ "civ": "civA" }, { "civ": "civB" }]}, { "notciv": "civC" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civA"), [{ "techs": ["tech1"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civC"), false);

template.requirements = 
{ "any": [{ "all": [{ "civ": "civA" }, { "tech": "tech1" }] }, { "tech": "tech2" }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civA"), [{ "techs": ["tech1"] }, { "techs": ["tech2"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civB"), [{ "techs": ["tech2"] }]);

template.requirements =
{ "any": [{ "all": [{ "civ": "civA" }, { "tech": "tech1" }] }, { "all": [{ "civ": "civB" }, { "tech": "tech2" }] }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civA"), [{ "techs": ["tech1"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civB"), [{ "techs": ["tech2"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civC"), false);

template.requirements =
{ "any": [{ "all": [{ "civ": "civA" }, { "tech": "tech1" }] }, { "all": [{ "any": [{ "civ": "civB" }, { "civ": "civC" }] }, { "tech": "tech2" }] }] };
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civA"), [{ "techs": ["tech1"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civC"), [{ "techs": ["tech2"] }]);
TS_ASSERT_UNEVAL_EQUALS(DeriveTechnologyRequirements(template, "civD"), false);
